'******************************************
'Programme de gestion robot d'initiation
'******************************************
'Port 0 = Contact droit
'Port 1 = Contact gauche
'Port 8 = Dvalidation des tages de puissance  0
'Port 9 = Mode demi-pas  0
'Port 10 = Mode RUN  0, mode STEP  1
'Port 11 = Direction rotation moteur gauche
'Port 12 = Avance pas moteur gauche
'Port 13 = Avance pas moteur droit
'Port 14 = Direction rotation moteur droit
'Port 20 = Buzzer
'Port 21 = BP1
'Port 22 = BP2
'Port 23 = BP3
'Port 24 = BP4 
'Port 25 = BP5
'Port 26 = BP6
'Port 27 = BP7
'Port 28 = BP8
'*******************************************
'Dclaration du type de microcontrleur
const device=3h
'*******************************************
'Dclarations des variables
dim T as byte 'Temporisation
'*******************************************
out 8,0:'Dvalidation des tages de puissance
out 9,1:'Mode pas entier
out 10,0:'Mode RUN
out 12,1
out 13,1
gosub son1
programme:
	if in(21)=0 then gosub avance
	if in(22)=0 then gosub recule
	if in(23)=0 then gosub droite
	if in(24)=0 then gosub gauche
	if in(26)=0 then gosub avance_seule
	'if in(27)=0 then gosub
	'if in(28)=0 then gosub
	goto programme
avance:
	beep 20
	out 11,0
	out 14,1
	out 8,1
	goto arrt
recule:
	beep 20
	out 11,1
	out 14,0
	out 8,1
	goto arrt
droite:
	beep 20
	out 11,1
	out 14,1
	out 8,1
	goto arrt
gauche:
	beep 20
	out 11,0
	out 14,0
	out 8,1
	goto arrt
arrt:
	if in(25)=0 then out 8,0
	if in(25)=0 then goto programme
	if in(25)=1 then goto arrt
avance_seule:
	out 11,0
	out 14,1
	out 8,1
	gosub contacts
	gosub contact_droit
	gosub contact_gauche
	gosub fin
	goto avance_seule
	return
contacts:
	delay 300
	if in(0)=1 and in(1)=1 then return
	if in(0)=0 and in(1)=0 then gosub recule_dg
	return
contact_droit:
	if in(0)=1 then return
	if in(0)=0 then gosub recule_droit
	return
contact_gauche:
	if in(1)=1 then return
	if in(1)=0 then gosub recule_gauche
	return
recule_dg:
	gosub son2
	out 8,0
	out 11,1
	out 14,0
	out 8,1
	delay 3000
	out 11,0
	out 14,0
	delay 2000
	return	
recule_droit:
	gosub son2
	out 8,0
	out 11,1
	out 14,0
	out 8,1
	delay 1000
	out 11,0
	out 14,0
	delay 300
	return
recule_gauche:
	gosub son2
	out 8,0
	out 11,1
	out 14,0
	out 8,1
	delay 1000
	out 11,1
	out 14,1
	delay 300
	return
fin:
	if in(25)=0 then out 8,0
	if in(25)=0 then goto programme
	return	
son1:
	for T=0 to 6
	beep 20
	delay 60
	next T
	return
son2:
	for T=0 to 2
	beep 20
	delay 30
	next T
	return
